### Définition de contraintes spécifiques sur l’entité

Les contraintes sur les entités correspondent à des fonctions d’évaluation de FME ou des fonctions Python visant à effectuer des calculs de valeurs sur un ou plusieurs attributs de type d’entité. La fonction retourne un booléen en fonction du résultat du calcul.

#### Définition de contraintes spécifiques sur l’entité dans l’arbre

Le nœud ![](../../Ressources/Images/contraintes_spe_entite.png)contient toutes les contraintes spécifiques sur une entité.

La fonction **Ajouter une contrainte spécifique** du menu contextuel permet de créer une nouvelle contrainte spécifique sur l’entité. Lors du clic sur cet élément du menu, une nouvelle contrainte est ajoutée à la liste et l’interface de création de la contrainte est affichée.

[En savoir plus sur les langages de définition de contraintes spécifiques et obtenir des exemples.](../../04-ContraintesRessources/04.LangagesDefinition.html)

![](../../Ressources/Images/Interface_contrainte_entites_684x344.png)

L’utilisateur définit un nom de contrainte, puis sélectionne le langage utilisé. Il sélectionne ensuite la fonction à utiliser. Les fonctions sont directement éditables en cliquant sur le bouton <big style="font-weight: bold;">+</big> qui redirige vers l’interface d’édition de code.

<span style="color: #943a99;">==> Erreurs retournées : E0035 (Non-respect de la contrainte spécifique sur le type d’entité).</span>

<span style="color: #943a99;">==> Erreurs retournées : E0045 (Violation de la contrainte Python sur l’entité).</span>

##### Exemple

La superficie des parcelles du cadastre (attribut SUPF) est parfois incohérente avec la superficie calculée à partir de la géométrie. Dans l’exemple ci-après, on recherche ces incohérences en définissant une contrainte fme_evaluate sur l’entité. Elle vérifie que l’écart entre superficie annoncée (attribut SUPF) et la superficie calculée ne doit pas dépasser 10% de la superficie annoncée :

```
abs(@Value(SUPF)-@Area(1))/@Value(SUPF) < 0.10
```

#### Définition de contraintes spécifiques dans la liste

En cliquant dans l’arbre, sur le nœud **type d’entité** d’un schéma ![](../../Ressources/Images/clic_TE.png), la liste des types d’entité composant le schéma s’affiche dans la fenêtre de droite. La liste permet de visualiser tous les types d’entité et les contraintes définies dans le formulaire de création. L’onglet **Spécifique** de la liste permet d’afficher la liste de toutes les contraintes spécifiques sur les entités du schéma en cours.

![](../../Ressources/Images/liste_contrainte_spcecifique.png)